<?php

declare(strict_types=1);

namespace Drupal\headless_cms_preview\PageCache\RequestPolicy;

use Drupal\Core\PageCache\RequestPolicyInterface;
use Drupal\headless_cms_preview\PreviewToken\PreviewTokenNegotiator;
use Symfony\Component\DependencyInjection\Attribute\AutoconfigureTag;
use Symfony\Component\HttpFoundation\Request;

/**
 * Request policy for headless previews.
 */
#[AutoconfigureTag('page_cache_request_policy')]
class HeadlessPreviewRequestPolicy implements RequestPolicyInterface {

  public function __construct(
    protected readonly PreviewTokenNegotiator $previewTokenNegotiator,
  ) {}

  /**
   * {@inheritdoc}
   */
  public function check(Request $request) {
    if ($this->previewTokenNegotiator->requestHasPreviewToken($request)) {
      return static::DENY;
    }

    return static::ALLOW;
  }

}
